#   Copyright Graham Jones 2014

#   This code is released under the Creative Commons 
#   Attribution-NonCommercial 4.0 International (CC BY-NC 4.0)
#   licence, found here:
#   http://creativecommons.org/licenses/by-nc/4.0/


make.beast2xml.init <- function(sim.options) {
  nofgenes <- sim.options$nofgenes
  commentln("rootHeight must be fixed so that BirthDeathCollapseModel can set bigger originHeight")
  catln(1, "<init", 
        id("randomSpeciesTree"),
        spec("RandomTree"),
        namevalue("estimate", "false"),
        namevalue("taxonset", IDtoREF(taxonSetOfSetsID())),
        namevalue("initial", IDtoREF(smcTreeID())),
        namevalue("rootHeight", "0.05"),
        ">")
  make.popmodel("ConstantPopulation.smc", "randomPopSize.smc") 
  catln(1, "</init>")
        

  for (g in 1:nofgenes) {
    catln(1, "<init", 
          id(paste0("randomGeneTree.", g)),
          spec("RandomGeneTree"),
          namevalue("estimate", "false"),
          namevalue("taxonset", IDtoREF(geneTaxonSetID(g))),
          namevalue("initial", IDtoREF(geneTreeID(g))), 
          namevalue("speciesTree", IDtoREF(smcTreeID())), ">")
    make.popmodel(paste0("RGTPopulationModel.", g), paste0("RGTPopSize.", g))
    catln(1, "</init>")  
  }
}
     
make.popmodel <- function(popmodelID, popsizeID) {
  catln(2, "<populationModel",
        id(popmodelID),
        spec("ConstantPopulation"), ">")
  catln(3, "<parameter", id(popsizeID), name("popSize"), ">0.05</parameter>")
  catln(2, "</populationModel>")  
}



# 
# <init estimate="false" id="RandomTree.t:Species" 
#initial="@Tree.t:Species" spec="beast.evolution.tree.RandomTree" taxonset="@taxonsuperset">
#   <populationModel id="ConstantPopulation0.Species" spec="ConstantPopulation">
#   <parameter id="randomPopSize.Species" name="popSize">1.0</parameter>
#   </populationModel>
#   </init>
#   
#   <init estimate="false" id="RandomGeneTree.t:29" initial="@Tree.t:29" 
#spec="beast.evolution.speciation.RandomGeneTree" speciesTree="@Tree.t:Species" taxa="@29">
#   <populationModel id="RGTPopulationModel.t:29" spec="ConstantPopulation">
#   <parameter id="RGTPopSize.t:29" name="popSize">1.0</parameter>
#   </populationModel>
#   </init>
#   
#   <init estimate="false" id="RandomGeneTree.t:26" initial="@Tree.t:26" spec="beast.evolution.speciation.RandomGeneTree" speciesTree="@Tree.t:Species" taxa="@26">
#   <populationModel id="RGTPopulationModel.t:26" spec="ConstantPopulation">
#   <parameter id="RGTPopSize.t:26" name="popSize">1.0</parameter>
#   </populationModel>
#   </init>
#   
# 
# 







