#   Copyright Graham Jones 2014

#   This code is released under the Creative Commons 
#   Attribution-NonCommercial 4.0 International (CC BY-NC 4.0)
#   licence, found here:
#   http://creativecommons.org/licenses/by-nc/4.0/


#############################################################
#####         low level utility routines       ##############
#############################################################

namevalue <- function(nam, val) {
  paste(nam, "=\"", val, "\"", sep="") 
}

id <- function(ID) { 
  paste("id=\"", ID, "\"", sep="")
}


spec <- function(s) { 
  paste("spec=\"", s, "\"", sep="")
}


name <- function(n) { 
  paste("name=\"", n, "\"", sep="")
}


idref <- function(element, id, name) {
  if (is.null(name)) {
    paste("<", element, " idref=\"", id, "\"", "/>", sep="")     
  } else {
    paste("<", element, " idref=\"", id, "\"", " name=\"", name, "\"/>", sep="")     
  }
}  
 

IDtoREF <- function(ID) {
  paste0("@", ID)
}


catln <- function(indent, ...) {
  if (indent == 0) {
    cat(..., "\n")
  } else {
    tabs <- paste(rep("\t", indent), sep="", collapse="")
    cat(tabs, ..., "\n") 
  }
}

commentln <- function(txt) {
  cat("<!-- ", txt, " -->\n"); 
}

bigcomment <- function(txt) {
  fullline <- paste0(rep("_", 45), collapse="")
  halftextlen <- as.integer(round(nchar(txt)/2))
  if (halftextlen > 22) { halftextlen <- 22}
  partline <- paste0(rep("_", 23 - halftextlen), collapse="")
  commentln(fullline)
  commentln(paste0(partline, "  ", txt, "  ", partline))
  commentln(fullline)
}


hugecomment <- function(txt) {
  xline <- paste0(rep("_", 45), collapse="")
  emptyline <- paste0(rep("_", 45), collapse="")
  partline <- paste0(rep("_", 16 - as.integer(round(nchar(txt)/2))), collapse="")
  commentln(xline)
  commentln(emptyline)
  commentln(paste0(partline, "( ( ( ( ( ( ( ", txt, " ) ) ) ) ) )", partline))
  commentln(emptyline)
  commentln(xline)
}


